<template>
    <div ref="container"></div>
</template>

<script setup lang="ts">
    import { onMounted, ref,watch } from 'vue';
    import Konva from 'konva';

    import { PLan } from "@/types/entities";


    // eslint-disable-next-line
    const props = defineProps<{
        items: PLan[],
        border: boolean
    }>();

    

    const container = ref();
    const layer = new Konva.Layer();
    let stage: Konva.Stage
    let border: Konva.Rect
    let echelleL:number
    let echellelarg: number
    const largeurPlan = 6.4
    const longueurPlan=12

    onMounted(() => {
       window.addEventListener('resize', resizeStage);
        stage = new Konva.Stage({
            container: container.value,
            width: container.value.offsetWidth,
            height: 550,

        });
        if (props.border) {
            border = new Konva.Rect({
                x: 0,
                y: 0,
                width: stage.width(),
                height: stage.height(),
                stroke: 'black',
                strokeWidth: 4 // La largeur de la bordure
            });
            layer.add(border)
        }

        stage.add(layer);
        charger()
    });


    function resizeStage() {
        resetStageForRedimension()
    }

    function resetStageForRedimension() {
        stage.width(container.value.offsetWidth)
        
        if (props.border)
            border.width(stage.width())

        layer.draw()
        charger()
    }



    watch(() => props.items,() => charger());

  async  function charger() {
      layer.removeChildren()
      if (props.border) {
          border = new Konva.Rect({
              x: 0,
              y: 0,
              width: stage.width(),
              height: stage.height(),
              stroke: 'black',
              strokeWidth: 4 // La largeur de la bordure
          });
          layer.add(border)
      }
         echelleL=stage.width()/longueurPlan
        echellelarg = stage.height() / largeurPlan

        props.items.forEach((x:PLan) => {

            const rect = new Konva.Rect({
                x: Number((Number(x.x)*Number(echelleL)).toFixed(1)),
                y: Number((Number(x.y)*Number(echellelarg)).toFixed(1)),
                width: Number((Number(x.longueur)*Number(echelleL)).toFixed(1)),
                    height: Number((Number(x.largeur)*Number(echellelarg)).toFixed(1)),
                fill: 'rgb(50,205,50)',
                stroke: 'black',
                strokeWidth: 2,
                id: x.id
            });

            const text = new Konva.Text({
                x: rect.x() + 10,
                y: rect.y() + rect.height() / 2 - 10,
                text: x.nom,
                fontSize: 12,
                fontFamily: 'Arial',
                fill: 'black',
                id: x.id
            });

            layer.add(rect);
            layer.add(text);
            layer.draw();

        })
    }

</script>